#include <sourcemod>
#include <sdktools>
#include <cstrike>
#define PLUGIN_VERSION	"1.1"
public Plugin:myinfo =
{
	name = "[FIX CSGO]Resurrect",
	author = "horr0rjkee (+inklesspen)",
	description = "Type !revive in chat to respawn your teammate",
	version = PLUGIN_VERSION
};
new g_offsCollisionGroup;
new PlayerRagdoll[MAXPLAYERS+1], Ragdolls[MAXPLAYERS+1], TimeRespawning[MAXPLAYERS+1], RespawningRagdoll[MAXPLAYERS+1], TimeNoCollision[MAXPLAYERS+1];
new String:servercmds[8][64] = {"revive_enabled", "revive_radius", "revive_time", "revive_noblock_time", "revive_health_cost", "revive_soundpath", "revive_version", "revive_cmds"};
new Handle:mainTimer=INVALID_HANDLE, Handle:cv_plugin_enabled,Handle: cv_revive_radius, Handle:cv_revive_time, Handle:cv_noblock_time;
public OnPluginStart() {
	for(new i = 0; i < sizeof(Ragdolls); i++) Ragdolls[i]=-1;
	HookEvent("player_death", OnPlayerDeath);
	HookEvent("round_start", Advertise);
	g_offsCollisionGroup = FindSendPropOffs("CBaseEntity", "m_CollisionGroup");
	mainTimer = CreateTimer(1.0, RespawnTimer, _, TIMER_REPEAT); 
	cv_plugin_enabled=CreateConVar("revive_enabled", "1", "(1/0 - Enable / disable) plugin");
	cv_revive_radius=CreateConVar("revive_radius", "100.0", "Radius to respawn death player");
	cv_revive_time=CreateConVar("revive_time", "10", "Time for respawn in seconds");
	cv_noblock_time=CreateConVar("revive_noblock_time", "3", "Noblocking time after respawn (set at 0 if you have any noblock plugin)");
	CreateConVar("revive_version", PLUGIN_VERSION, "Resurrection mod version (author: horr0rjkee)", FCVAR_PLUGIN | FCVAR_SPONLY | FCVAR_REPLICATED | FCVAR_NOTIFY);
	RegServerCmd("revive_cmds", ShowReviveCmds);
	HookConVarChange(cv_plugin_enabled, OnPluginEnablex);
}
public Action:ShowReviveCmds(args)
{
	PrintToServer("###### Resurrection mod commands: ######");
	for(new i = 0; i < sizeof(servercmds); i++) PrintToServer("#%i. \"%s\"", i+1, servercmds[i]);
	PrintToServer("######-----Author: horr0rjkee-----######");
	return Plugin_Handled;
}
public OnPluginEnablex(Handle:cvar, const String:oldVal[], const String:newVal[]) {
	if(StringToInt(newVal) > 0) {	
		if(mainTimer == INVALID_HANDLE) mainTimer = CreateTimer(1.0, RespawnTimer, _, TIMER_REPEAT); 
		ServerCommand("mp_restartgame 1");
		PrintToChatAll("\x03[Resurrect] \x04 Плагин воскрешения включен!");
	}
	else {
		KillTimer(mainTimer);
		mainTimer=INVALID_HANDLE;
		PrintToChatAll("\x03[Resurrect] \x04 Плагин воскрешения выключен!");
	}
}

public OnSetConvarSoundpath(Handle:cvar, const String:oldVal[], const String:newVal[])
{
	new String:soundpath[256];
	Format(soundpath, sizeof(soundpath), "sound/%s", newVal);
	if(!FileExists(soundpath)) PrintToServer("File \"%s\" isn't found", soundpath);
	else {
		PrecacheSound(newVal);
		AddFileToDownloadsTable(soundpath);
	}
}
public Action:OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)  {
	if(!GetConVarInt(cv_plugin_enabled)) return Plugin_Continue;
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
	BreakRespawning(client, true);
	PlayerRagdoll[client]=ragdoll;
	CalculateRagdolls();
	return Plugin_Continue;
}
public Action:RespawnTimer(Handle:timer) {
	if(!GetConVarInt(cv_plugin_enabled)) return Plugin_Stop;
	for(new i = 1, Float:ragpos[3]; i < GetMaxClients()+1;i++) {
		if(IsClientInGame(i)) {
			if(TimeNoCollision[i] > 0) {
				if(TimeNoCollision[i] == 1) SetClientCollision(i, false);
				TimeNoCollision[i]--;
			}
			if(TimeRespawning[i] > 0) {
				decl String:arg[256]
				GetEntityClassname(RespawningRagdoll[i], arg, sizeof(arg))
				if(IsValidEntity(RespawningRagdoll[i])&&!StrEqual(arg, "weaponworldmodel"))
				GetEntPropVector(RespawningRagdoll[i], Prop_Send, "m_vecOrigin", ragpos);
				if((GetClientButtons(i) & IN_USE) && IsClientInRangeOfPoint(i, GetConVarFloat(cv_revive_radius), ragpos) && (GetEntityFlags(i) & FL_ONGROUND)) {
					if(TimeRespawning[i]==1) InitRespawn(i, RespawningRagdoll[i]);
					TimeRespawning[i]--;
				}
				else BreakRespawning(i, true);
			}
		}
	}
	return Plugin_Handled; 
}
stock Action:BreakRespawning(client, bool:typemsg=false)
{
	new deathplayer = GetClientIndexByRagdoll(RespawningRagdoll[client]);
	if(typemsg==true && deathplayer>0 && IsValidEdict(deathplayer) && IsClientInGame(deathplayer)) PrintToChat(client, "\x03[Resurrect] \x04Вы прекратили воскрешать \x03%N", deathplayer);
	SendProgressBar(client, 0);
	TimeRespawning[client]=0;
	RespawningRagdoll[client]=0;
	//TimeNoCollision[client]=0;
	if(GetConVarInt(cv_noblock_time) > 0) SetClientCollision(client, false);
	return Plugin_Handled;
}
public Action:Advertise(Handle:event, const String:name[], bool:dontBroadcast) {
	if(!GetConVarInt(cv_plugin_enabled)) return Plugin_Continue;
	for(new i = 1; i < GetMaxClients()+1; i++) if(IsValidEdict(i) && IsClientInGame(i)) BreakRespawning(i);
	PrintToChatAll("\x03[Resurrect] \x04Чтобы воскресить павшего союзника, встаньте рядом с его трупом и зажмите клавишу \x03E");
	return Plugin_Continue;
}
public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if(!GetConVarInt(cv_plugin_enabled) || !IsPlayerAlive(client)) return Plugin_Continue;
	new Float:ragpos[3], String:classname[64], deathplayer, revive_time=GetConVarInt(cv_revive_time);
	if(TimeRespawning[client] > 0 && RespawningRagdoll[client] > 0) return Plugin_Continue;
	if ((buttons & IN_USE) && GetEntityFlags(client) & FL_ONGROUND) {
		for(new i = 1; i < sizeof(Ragdolls); i++) {
			if(Ragdolls[i] > 0 && IsValidEdict(Ragdolls[i])) {
				GetEdictClassname(Ragdolls[i], classname, sizeof(classname));
				if(StrEqual(classname, "cs_ragdoll")) {
					deathplayer=GetClientIndexByRagdoll(Ragdolls[i]);
					{
						if(!IsClientInGame(deathplayer)||IsPlayerAlive(deathplayer))
						{
							BreakRespawning(client)
							return Plugin_Continue
						}
						if(GetClientTeam(client) == GetClientTeam(deathplayer) && IsClientInGame(deathplayer)) {
							GetEntPropVector(Ragdolls[i], Prop_Send, "m_vecOrigin", ragpos);
							if(IsClientInRangeOfPoint(client, GetConVarFloat(cv_revive_radius), ragpos)) {
								if(revive_time > 1) {
									TimeRespawning[client]=revive_time; //время до воскрешения
									PrintToChat(client, "\x03[Resurrect] \x04Вы воскрешаете \x03%N", deathplayer);
									PrintToChat(deathplayer, "\x03[Resurrect] \x04Вас воскрешает игрок \x03%N", client);
									SendProgressBar(client, revive_time);
									RespawningRagdoll[client] = Ragdolls[i];
								}
								else InitRespawn(client, Ragdolls[i]);
								break;
							}
						}
					}
					
				}
			}
		}
	}
	return Plugin_Continue;
}
stock Action:InitRespawn(client, ragdoll) {
	SendProgressBar(client, 0)
	
	if(!IsValidEntity(ragdoll))
	{
		BreakRespawning(client);
		return Plugin_Handled;
	}
	
	new deathplayer = GetClientIndexByRagdoll(ragdoll), Float:ragpos[3], deaths=GetEntProp(deathplayer, Prop_Data, "m_iDeaths");
	GetEntPropVector(ragdoll, Prop_Send, "m_vecOrigin", ragpos);
	if(IsClientInGame(deathplayer) && IsPlayerAlive(deathplayer))
	{
		BreakRespawning(client);
		return Plugin_Handled;
	}
	if(IsClientInGame(deathplayer) && !IsPlayerAlive(deathplayer) && GetClientTeam(client) == GetClientTeam(deathplayer)) {
		BreakRespawning(client);
		CS_RespawnPlayer(deathplayer);
		TeleportEntity(deathplayer, ragpos, NULL_VECTOR, NULL_VECTOR);
		RemoveEdict(ragdoll);
		PlayerRagdoll[deathplayer]=-1;
		if(deaths > 0) SetEntProp(deathplayer, Prop_Data, "m_iDeaths", deaths-1);
		SetEntProp(client, Prop_Data, "m_iFrags", GetEntProp(client, Prop_Data, "m_iFrags")+1);
		PrintToChat(client, "\x03[Resurrect] \x04Вы воскресили \x03%N \x04 и получили фраг за это", deathplayer);
		
		CalculateRagdolls();
		if(GetConVarInt(cv_noblock_time) > 0) {
			TimeNoCollision[deathplayer]=GetConVarInt(cv_noblock_time);
			SetClientCollision(deathplayer, true);
		}
	}
	return Plugin_Handled;
}
stock CalculateRagdolls() {
	for(new i = 0; i < sizeof(Ragdolls); i++) Ragdolls[i]=-1;
	for(new i = 1, index=0; i < GetMaxClients()+1; i++) {
		if(PlayerRagdoll[i] != -1) {
			Ragdolls[index]=PlayerRagdoll[i];
			index++;
		}
	}
}
stock GetClientIndexByRagdoll(ragdoll) {
	new index=-1;
	for(new i = 0; i < GetMaxClients()+1; i++) {
		if(PlayerRagdoll[i] == ragdoll) {
			index=i;
			break;
		}
	}
	return index;
}
stock IsClientInRangeOfPoint(client, Float:radius, Float:cpos[3]) {
	if(!IsClientInGame(client)) return false;
	new Float:ppos[3];
	GetClientAbsOrigin(client, ppos);
	if(GetDistance(ppos, cpos) <= radius) return true;
	return false;
}
stock Float:GetDistance(Float:pos1[3], Float:pos2[3]) return SquareRoot( Pow(pos2[0] - pos1[0], 2.0) + Pow(pos2[1] - pos1[1], 2.0) + Pow(pos2[2]-pos1[2], 2.0) );
stock SendProgressBar(client, time){
	if(time > 0) { 
		SetEntPropFloat(client, Prop_Send, "m_flProgressBarStartTime", GetGameTime());
		SetEntProp(client, Prop_Send, "m_iProgressBarDuration", time);
	}
	else {
		SetEntPropFloat(client, Prop_Send, "m_flProgressBarStartTime", 0.0);
		SetEntProp(client, Prop_Send, "m_iProgressBarDuration", 0);
	}
}
stock SetClientCollision(client, bool:collision=false) {
	if(collision==false) SetEntData(client, g_offsCollisionGroup, 5, 4, true); //block
	else SetEntData(client, g_offsCollisionGroup, 2, 4, true); //unblock
}